\ core-ext   10/04/97  gwj
create core-ext

\ nonstandard utilities
: <#s>   ( d -- addr cnt )  <# #s #> ;

\ standard words
: .r  ( n chars -- )  >r s>d <#s>
 r> over - 0 max spaces type ;
: u.r  ( n chars -- )  >r 0 <#s>
 r> over - 0 max spaces type ;
: 0<>  ( n -- f )  0= invert ; inline
: 0>  ( n -- f )   0 > ; inline

: 2>r  ( n1 n2 -- )  swap >r >r ; inline
: 2r>  ( -- n1 n2 )  r> r> swap ; inline
: 2r@  ( -- n1 n2 )  
r> r> 2dup >r >r swap ; inline

: c"  ( "ccc<">" -- )
  postpone ahead   [char] " word
  dup >r c@ char+ allot align
  postpone then r> postpone literal ;
immediate
: erase  ( addr cnt -- )  0 fill ;
: within  ( n1 n2 n3 -- f ) 
 rot tuck < rot rot >  or 0= ;

\ pre-safe version
: :noname  ( -- xt )
   align here 0 , 0 , here swap ] ;
\ 'safe' version
\ : :noname  :noname colon-tag swap ;